.586p
.model flat,stdcall
option casemap:none
include		  \masm32\include\windows.inc
include		  \masm32\include\user32.inc
include		  \masm32\include\kernel32.inc
include		  \masm32\include\comctl32.inc
include		  \masm32\include\comdlg32.inc

includelib	 \masm32\lib\comctl32.lib
includelib	 \masm32\lib\comdlg32.lib
includelib	 \masm32\lib\kernel32.lib
includelib	 \masm32\lib\user32.lib

b equ byte ptr
w equ word ptr
d equ dword ptr
q equ qword ptr
f equ fword ptr
o equ offset
IDD_DIALOG	equ 100
BTN_FILE	equ 110
BTN_OEP		equ 111
BTN_EXIT	equ 112
IDC_FILE	equ 120
IDC_EDIT1	equ 121
IDC_EDIT2	equ 122
IDC_CHECK	equ 130
EXCEPTION_GUARD_PAGE	EQU 080000001h

DlgProc		proto :dword,:dword,:dword,:dword

.data?
context		CONTEXT <>
ofn		OPENFILENAME <>
sinfo		STARTUPINFO <>
pinfo		PROCESS_INFORMATION <>
ldte		LDT_ENTRY <>
dbevent		DEBUG_EVENT <>
fs30		dd ?
buffer		db 512 dup (?)
hInst		dd ?
hIcon		dd ?
basestart	dd ?
baseend		dd ?
range		dd ?
empty		dd ?
pehdr		db 1024 dup (?)
oeptext		db 9 dup (?)
edit1		db 9 dup (?)
edit2		db 9 dup (?)
zero		db ?
faster		db ?
counter		db ?

.data
assume cs:nothing
filterstring	db "exe files",0,"*.exe",0,"all files",0,"*.*",0,0
oepcapt		db "Oep is:",0

.code
start:
	invoke InitCommonControls
	invoke GetModuleHandle,0
	mov [hInst],eax
	invoke LoadIcon,[hInst],900
	mov [hIcon],eax
	invoke DialogBoxParam,[hInst],IDD_DIALOG,0,o DlgProc,0
	invoke ExitProcess,0



DlgProc proc,hDlg:dword,uMsg:dword,wParam:dword,lParam:dword
	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne initiated
	invoke SendMessage,[hDlg],WM_SETICON,1,[hIcon]
	invoke CheckDlgButton,[hDlg],IDC_CHECK,BST_CHECKED
initiated:
	cmp eax,WM_CLOSE
	je _wmclose
	cmp eax,WM_COMMAND
	jne maybe_move
	cmp [wParam],BTN_FILE
	je get_file
	cmp [wParam],BTN_OEP
	je find_oep
	cmp [wParam],BTN_EXIT
	je _wmclose
maybe_move:
	cmp eax,WM_LBUTTONDOWN
	jne unknown
	invoke SendMessage,[hDlg],WM_NCLBUTTONDOWN,HTCAPTION,0
unknown:
	xor eax,eax
	ret



_wmclose:
	invoke EndDialog,[hDlg],0
	jmp unknown



get_file:
	mov [ofn.lStructSize],sizeof ofn
	mov [ofn.lpstrFilter],o filterstring
	mov [ofn.lpstrFile],o buffer
	mov [ofn.nMaxFile],512
	mov [ofn.Flags],OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES
	invoke GetOpenFileName,o ofn
	or eax,eax
	je unknown
	invoke SetDlgItemText,[hDlg],IDC_FILE,o buffer

	invoke CreateFile,o buffer,GENERIC_READ,0,0,OPEN_EXISTING,20h,0
	push eax
	invoke ReadFile,eax,o pehdr,1024,o empty,0
	pop eax
	invoke CloseHandle,eax

	mov ebx,o pehdr
	add ebx,[ebx+3ch]
	mov eax,[ebx+34h]
	add eax,[ebx+104h]
	mov [basestart],eax
	mov ebx,[ebx+100h]
	mov [range],ebx
	add eax,ebx
	mov [baseend],eax

	mov ebx,[basestart]
	mov ecx,8
	mov edi,o edit1+7
	call hex
	mov ebx,[range]
	mov ecx,8
	mov edi,o edit2+7
	call hex
	invoke SetDlgItemText,[hDlg],IDC_EDIT1,o edit1
	invoke SetDlgItemText,[hDlg],IDC_EDIT2,o edit2
	jmp unknown



find_oep:
	invoke IsDlgButtonChecked,[hDlg],IDC_CHECK
	mov [faster],al
	invoke GetStartupInfo,o sinfo
	invoke CreateProcess,o buffer,0,0,0,0,DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS,0,0,o sinfo,o pinfo
	or eax,eax
	je unknown

	.while TRUE
	invoke WaitForDebugEvent,o dbevent,-1

	.if [dbevent.dwDebugEventCode]==EXIT_PROCESS_DEBUG_EVENT
	invoke ContinueDebugEvent,dbevent.dwProcessId,dbevent.dwThreadId,DBG_CONTINUE
	.break

	.elseif [dbevent.dwDebugEventCode]==CREATE_PROCESS_DEBUG_EVENT
	mov [context.ContextFlags],CONTEXT_FULL
	invoke GetThreadContext,pinfo.hThread,o context
	invoke GetThreadSelectorEntry,pinfo.hThread,context.regFs,o ldte
	mov ah,[ldte.HighWord1.Bytes.BaseHi]
	mov al,[ldte.HighWord1.Bytes.BaseMid]
	shl eax,16
	mov ax,[ldte.BaseLow]
	add eax,30h
	invoke ReadProcessMemory,pinfo.hProcess,eax,o fs30,4,0
	mov eax,[fs30]
	add eax,2
	invoke WriteProcessMemory,pinfo.hProcess,eax,o zero,1,0
	invoke VirtualProtectEx,pinfo.hProcess,basestart,range,PAGE_EXECUTE_READWRITE or PAGE_GUARD,o empty

	.elseif [dbevent.dwDebugEventCode]==LOAD_DLL_DEBUG_EVENT
	invoke VirtualProtectEx,pinfo.hProcess,basestart,range,PAGE_EXECUTE_READWRITE or PAGE_GUARD,o empty

	.elseif [dbevent.dwDebugEventCode]==EXCEPTION_DEBUG_EVENT
	.if [dbevent.u.Exception.pExceptionRecord.ExceptionCode]==EXCEPTION_BREAKPOINT
	invoke VirtualProtectEx,pinfo.hProcess,basestart,range,PAGE_EXECUTE_READWRITE or PAGE_GUARD,o empty

	.elseif [dbevent.u.Exception.pExceptionRecord.ExceptionCode]==EXCEPTION_GUARD_PAGE
	cmp [faster],0
	je do_guard
	inc [counter]
	and [counter],3
	cmp [counter],0
	jne no_guard
do_guard:
	invoke VirtualProtectEx,pinfo.hProcess,basestart,range,PAGE_EXECUTE_READWRITE or PAGE_GUARD,o empty
no_guard:
	invoke GetThreadContext,pinfo.hThread,o context
	mov ebx,[context.regEip]
	cmp ebx,[basestart]
	jb no_oep
	cmp ebx,[baseend]
	ja no_oep
	mov ecx,8
	mov edi,o oeptext+7
	call hex
	invoke MessageBox,[hDlg],o oeptext,o oepcapt,0
	invoke VirtualProtectEx,pinfo.hProcess,basestart,range,PAGE_EXECUTE_READWRITE,o empty
no_oep:
	invoke ContinueDebugEvent,dbevent.dwProcessId,dbevent.dwThreadId,DBG_CONTINUE
	.continue
	.endif
	.endif

	invoke ContinueDebugEvent,dbevent.dwProcessId,dbevent.dwThreadId,DBG_EXCEPTION_NOT_HANDLED
	.endw

	invoke CloseHandle,pinfo.hProcess
	invoke CloseHandle,pinfo.hThread
	jmp unknown
DlgProc endp



hex:
	mov eax,ebx
	and al,0fh
	add al,90h
	daa
	adc al,40h
	daa
	shr ebx,4
	mov [edi],al
	dec edi
	dec ecx
	jne hex
	ret
end start