@echo off

rem asm file name
set projectname_s_ext=pecom

rem name must be the exe
set finalname_s_ext=%projectname_s_ext%

rem This is our Final name ( We rename our .exe )
set finalname_s_ext=un-pecompact_0.1b
: -------------------------------
: if resources exist, build them
: -------------------------------
if not exist rsrc.rc goto over1
\masm32\bin\rc /v rsrc.rc
\masm32\bin\cvtres /machine:ix86 rsrc.res
:over1
 
if exist "%projectname_s_ext%.obj" del "%projectname_s_ext%.obj"
if exist "%projectname_s_ext%.exe" del "%projectname_s_ext%.exe"

\masm32\bin\ml /c /coff "%projectname_s_ext%.asm"
if errorlevel 1 goto errasm

if not exist rsrc.obj goto nores

\masm32\bin\Link /SUBSYSTEM:WINDOWS /OUT:%finalname_s_ext%.exe "%projectname_s_ext%.obj" rsrc.res
 if errorlevel 1 goto errlink

dir "%projectname_s_ext%.*"
goto TheEnd
: nores
: --------------------------------------------------
: link the main OBJ file with the resource OBJ file
: --------------------------------------------------
 \masm32\bin\Link /SUBSYSTEM:WINDOWS /OUT:%finalname_s_ext%.exe "%projectname_s_ext%.obj"
 if errorlevel 1 goto errlink
dir "%projectname_s_ext%.*"

rem Re name the final .exe

rename %projectname_s_ext%.exe %finalname_s_ext%.exe 

goto TheEnd

:errlink
: ----------------------------------------------------
: display message if there is an error during linking
: ----------------------------------------------------
 echo _
echo Link error
goto TheEnd

:errasm
: -----------------------------------------------------
: display message if there is an error during assembly
: -----------------------------------------------------
 echo _
echo Assembly Error
goto TheEnd

:TheEnd
 echo _
echo Deleting files time
if exist *.res del /q *.res
if exist *.obj del /q *.obj 
pause>nul
