; simple unpacker for pecompact written by Mirza
;All comments, errors, etc., send e-mail:
; mirz@o2.pl
.386
.model flat,stdcall
OPTION CASEMAP:NONE

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib

SetBreakpoint 		PROTO :DWORD	    ;procedure for putting breakpoint
CheckPE			    PROTO		        ;procedure to check the PE
SignaturePeCompact	PROTO		        ;procedure to check whether it is PeCompact2.X
SearchOEP			PROTO  
UsunBreakpoint		PROTO :DWORD,:BYTE	;procedure to delete breakpoint
SearchIID			PROTO 
Dump				PROTO
Save				PROTO 

.CONST

.DATA

ofn 				OPENFILENAME <>
FilterString		db "Files (*.exe)",0,"*.exe",0,0
szTitle				db "[Un-PeCompact 0.1b] by mirz...[ENGLISH VERSION]",0
Error				db "error",0 
Error_File 			db "I can not get to have obtained access to the file",0 
Error_Unknown		db "Unknown error",0 
Error_Memory	    db "I can not get the memory allocated",0 
Error_PE			db "Incorrect PE !!!",0 
Error_Process		db "I can not get the process created",0 
Error_PECompact		db "I have not found PECompact2.x :(",0
Lack_Of				db "Warning",0 
PEComp				db "PECompact2",0
Found_Title			db "[Un-PeCompact 0.1b]",0
I_Found			    db "I found PECompact 2.X",0dh,0Ah,
						"Do you want to unpack ?",0
break				db 0CCh		;int3
repairwSize			db 06Ah 
repairWhere			db 05Ah 
repairIAT			db 0FFh 
AddressOfEntryPoint	DD 0
SizeOfImage			DD 0
ImageBase			DD 0
NumberOfSections	DD 0
comparison			DD 0 
patchOEP			DD 0
patchSize			DD 0
patchIAT			DD 0
sizeVirtual			DD 0
patchWhere			DD 0
where				DD 0
patchIID			DD 0
addressIID			DD 0
breakFixIDD			DW 08AE9h
breakFixIDD1		DD 090000000h
usunIID				DB 085h
OEP					DD 0
repairOEP			DB 05Dh 
Characteristics		DD 0
unpacked			db "unpacked.exe",0
ok					DB "ok",0
Done			    DB "Done :)",0 

.DATA?

buffer 					db 512 dup(?)
hFile					HANDLE ?
pFile					HANDLE ?
MapSize					dd ?
SizeReadWrite			DWORD ?
startupinfo				STARTUPINFO <>
PI_						PROCESS_INFORMATION <>
DBE						DEBUG_EVENT <>
context					CONTEXT <>
MapAddress				dd ?
hMemory					HANDLE ?
pMemory					DWORD ?
pMapVirtual				DD ?

.CODE

start:

	mov ofn.lStructSize,SIZEOF ofn
	mov ofn.lpstrFilter,OFFSET FilterString
	mov ofn.lpstrFile,OFFSET buffer
	mov ofn.nMaxFile,512
	mov ofn.lpstrTitle,OFFSET szTitle
	mov ofn.Flags,OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST
	invoke GetOpenFileName,addr ofn						;with the file dialog to open
	.if eax==TRUE
		invoke CreateFile,addr buffer,GENERIC_READ,FILE_SHARE_READ,\		
					NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
		.if EAX==INVALID_HANDLE_VALUE					;if you can not access a file
			invoke MessageBox,0,ADDR Error_File ,ADDR Error,MB_ICONERROR
			jmp Finish 
		.endif
		mov [hFile],eax							;file handle
		invoke GetFileSize,hFile,NULL
		mov [MapSize],eax
		invoke VirtualAlloc,NULL,EAX,MEM_COMMIT,PAGE_EXECUTE_READWRITE		;allocate memory
		.if !EAX
			invoke MessageBox,0,ADDR Error_Memory,ADDR Error,MB_ICONERROR
			jmp Memory_Finish 
		.endif
		mov [MapAddress],eax
		invoke ReadFile,hFile,EAX,MapSize,ADDR SizeReadWrite,NULL			;read file
		invoke CheckPE 
		test eax,eax
		je Memory_Finish			;jump if error
		invoke GetStartupInfo,ADDR startupinfo
		invoke CreateProcess,addr buffer,NULL, NULL, NULL, FALSE,\			;create process
						DEBUG_PROCESS OR DEBUG_ONLY_THIS_PROCESS,\
						NULL, NULL, ADDR startupinfo, ADDR PI_
		.if !EAX
			invoke MessageBox,0,ADDR Error_Process,ADDR Error,MB_ICONERROR		;I can not create error process
			jmp Memory_Finish
		.endif
		invoke GlobalAlloc,GPTR,SizeOfImage
		mov  hMemory,eax
		invoke GlobalLock,hMemory
		mov  pMemory,eax
		invoke ReadProcessMemory,PI_.hProcess,ImageBase,pMemory,SizeOfImage,0		;read process
		invoke SearchOEP 
		.while TRUE
			invoke WaitForDebugEvent,ADDR DBE,INFINITE
			.if !eax
				invoke MessageBox,0,ADDR Error_Unknown,ADDR Error,MB_ICONERROR	; something went wrong
				.break
			.endif
			.if DBE.u.Exception.pExceptionRecord.ExceptionCode==EXCEPTION_BREAKPOINT
				mov context.ContextFlags,CONTEXT_CONTROL
				invoke GetThreadContext,PI_.hThread,addr context
				mov eax,context.regEip
				.if eax==[patchOEP]
					mov context.ContextFlags,CONTEXT_INTEGER
					invoke GetThreadContext,PI_.hThread,addr context
					mov eax,context.regEax	;eax will address the OEP
					mov [OEP],eax
					invoke UsunBreakpoint,patchOEP,repairOEP 
					invoke Dump				;dump process
					invoke Save 
					.break
				.elseif eax==[patchSize]
					mov context.ContextFlags,CONTEXT_INTEGER
					invoke GetThreadContext,PI_.hThread,addr context
					mov ebx,context.regEbx			;Picking ebx
					add ebx,4						; Now go to the size of
					invoke ReadProcessMemory,PI_.hProcess,ebx,pMemory,4,0
					mov eax,pMemory					
					mov eax,dword ptr[eax]
					mov [sizeVirtual],eax			;type size is useful later in
					invoke UsunBreakpoint,patchSize,repairwSize 
				.elseif eax==[patchWhere]			
					mov context.ContextFlags,CONTEXT_INTEGER
					invoke GetThreadContext,PI_.hThread,addr context
					mov ebx,context.regEax			;Picking eax value thanks to this you will know
					mov [where],ebx					;where the program memory allocated
					invoke UsunBreakpoint,patchWhere,repairWhere
				.elseif eax==[patchIAT]
					mov context.ContextFlags,CONTEXT_INTEGER
					invoke GetThreadContext,PI_.hThread,addr context
					invoke VirtualAlloc,NULL,sizeVirtual,MEM_COMMIT,PAGE_EXECUTE_READWRITE ;load the memory needed
					mov [pMapVirtual],eax
					mov ebx,context.regEdi
					sub ebx,[where]
					mov edx,[sizeVirtual]
					sub edx,ebx						  ;Now if we have read
					mov ebx,context.regEdi
					invoke ReadProcessMemory,PI_.hProcess,ebx,pMapVirtual,edx,0
					invoke SearchIID
					invoke VirtualFree,pMapVirtual,sizeVirtual,MEM_DECOMMIT		;after the operation we can release the memory
					invoke UsunBreakpoint,patchIAT,repairIAT
				.elseif eax==[patchIID]
					mov context.ContextFlags,CONTEXT_INTEGER
					invoke GetThreadContext,PI_.hThread,addr context
					mov eax,context.regEcx					;Picking the right address IID
					mov [addressIID],eax
					mov eax,[patchIID]						;We will not spoil
					inc eax
					invoke WriteProcessMemory,PI_.hProcess,EAX,addr breakFixIDD,2,NULL
					mov eax,[patchIID]
					add eax,3
					invoke WriteProcessMemory,PI_.hProcess,EAX,addr breakFixIDD1,4,NULL
					invoke UsunBreakpoint,patchIID,usunIID
				.endif
				invoke ContinueDebugEvent,DBE.dwProcessId,DBE.dwThreadId,DBG_CONTINUE
			.elseif DBE.dwDebugEventCode==EXIT_PROCESS_DEBUG_EVENT
				invoke MessageBox,0,ADDR Error_Unknown,ADDR Error,MB_ICONERROR
				.break
			.endif
			invoke ContinueDebugEvent,DBE.dwProcessId,DBE.dwThreadId,DBG_EXCEPTION_NOT_HANDLED
		.endw
		invoke TerminateProcess,PI_.hProcess,NULL		;kill process
		invoke Sleep,500								;Wait for killing
		invoke CloseHandle,PI_.hProcess					;close handle
		invoke CloseHandle,PI_.hThread					;close handle
		invoke GlobalUnlock,pMemory		                ;release memory
		invoke GlobalFree,hMemory
Memory_Finish:
		invoke CloseHandle,hFile				        ;close the file handle
		invoke VirtualFree,MapAddress,MapSize,MEM_DECOMMIT
	.endif
Finish:
	invoke ExitProcess,0

SetBreakpoint PROC BaseAddress:DWORD	;set a breakpoint at the command

	pushad
	dec [BaseAddress]		;need to change address
	invoke WriteProcessMemory,PI_.hProcess,BaseAddress,addr break,1,NULL	;set a breakpoint at the command
	popad
	Ret
SetBreakpoint EndP

CheckPE PROC 

	mov edi,MapAddress
	assume edi:ptr IMAGE_DOS_HEADER
	.if [edi].e_magic==IMAGE_DOS_SIGNATURE
		add edi,[edi].e_lfanew
		assume edi:ptr IMAGE_NT_HEADERS
		.if [edi].Signature==IMAGE_NT_SIGNATURE
			invoke SignaturePeCompact
		.else
			invoke MessageBox,0,ADDR Error_PE,ADDR Error,MB_ICONERROR	;error if pe is not correct
			xor eax,eax
		.endif
	.else
		invoke MessageBox,0,ADDR Error_PE,ADDR Error,MB_ICONERROR
		xor eax,eax
	.endif
	Ret
CheckPE EndP

SignaturePeCompact PROC

	assume edi:ptr IMAGE_NT_HEADERS
	mov eax,[edi].OptionalHeader.AddressOfEntryPoint			;This handy later to seek not only OEP and
	mov [AddressOfEntryPoint],eax
	mov eax,[edi].OptionalHeader.ImageBase						;This will need to read the process
	mov [ImageBase],eax
	mov eax,[edi].OptionalHeader.SizeOfImage					;This same
	mov [SizeOfImage],eax
	xor eax,eax
	mov ax,[edi].FileHeader.NumberOfSections
	mov [NumberOfSections],eax
	add edi,IMAGE_NT_HEADERS
	assume edi:ptr IMAGE_SECTION_HEADER
	mov ebx,[NumberOfSections]
	.while ebx!=0
		lea eax,[edi].Name1
		.if dword ptr[eax]=='EDOC'		;or section code
			mov eax,[edi].Characteristics
			mov [Characteristics],eax							;This is handy later
			mov eax,[edi].PointerToRawData						;Picking where is the RAWDATA
			add eax,MapAddress									;add this to MapAddress
			add eax,18h											;Now we are at the signature PECompact2.x
			mov [comparison],eax
			invoke lstrcmp,comparison,addr PEComp				;check whether it is PECompact
			.if !EAX
				invoke MessageBox,0,ADDR I_Found,ADDR Found_Title,MB_ICONQUESTION + MB_YESNO		;ask
				.if eax==6		
					mov eax,1	;if so, continue 
				.else
					xor eax,eax	;if it does not end
				.endif
				.break
			.else
				invoke MessageBox,0,ADDR Error_PECompact,ADDR Lack_Of,MB_ICONWARNING	;not found
				xor eax,eax
				.break
			.endif
		.endif
		add edi,IMAGE_SECTION_HEADER
		dec ebx
	.endw
	Ret
SignaturePeCompact EndP

SearchOEP PROC

	mov eax,[pMemory]					;pointer to the process here
	add eax,[AddressOfEntryPoint]		;go to Entry Point
	inc eax								;incremented by one (increases by one)
	mov ebx,[eax]						;get what you meant to be thrown into eax
	sub ebx,[ImageBase]					;subtract from the base image
	mov eax,pMemory						
	add eax,ebx							;Now add the value of what was to be in eax
	add eax,5							;go for a command
	mov ebx,eax							;puts it into ebx
	add ebx,[SizeOfImage]				;add imagebase and now you are ready to seek
	.while eax!=ebx
		.if dword ptr[eax]==0595F5E5Ah			;jump to OEP
			.if dword ptr[eax+4]==0E0FF5D5Bh
				add eax,6
				push eax
				sub eax,[pMemory]
				add eax,[ImageBase]
				mov [patchOEP],eax
				invoke SetBreakpoint,eax
				pop eax
				.break
			.endif
		.elseif dword ptr[eax]==890C4B8Bh		;search for magic call for IAT
			.if dword ptr[eax+4]==0D7FF144eh
				add eax,7
				push eax
				sub eax,[pMemory]
				add eax,[ImageBase]
				mov [patchIAT],eax
				invoke SetBreakpoint,eax
				pop eax
			.endif
		.elseif dword ptr[eax]==00100068h		;loop to search for virtual size
			.if dword ptr[eax+4]==00473FF00h
				push eax
				dec eax
				sub eax,[pMemory]
				add eax,[ImageBase]
				mov [patchSize],eax
				invoke SetBreakpoint,eax
				pop eax
			.endif
		.elseif dword ptr[eax]==050F88B5Ah		;breapoint as we call edi
			inc eax
			push eax
			sub eax,[pMemory]
			add eax,[ImageBase]
			mov [patchWhere],eax				;This is useful to  retrieve Address for later to rebuild IID
			invoke SetBreakpoint,eax
			pop eax
		.endif
		inc eax
	.endw
	Ret
SearchOEP EndP

UsunBreakpoint PROC BaseAddress:DWORD,napraw:BYTE			;remove breakpoint

	pushad
	mov context.ContextFlags, CONTEXT_i486 or CONTEXT_FULL
	invoke GetThreadContext,PI_.hThread,ADDR context
	dec context.regEip
	dec [BaseAddress]
	xor ebx,ebx
	lea ebx,[napraw]
	invoke WriteProcessMemory,PI_.hProcess,BaseAddress,ebx,1,0
	invoke ReadProcessMemory,PI_.hProcess,ImageBase,pMemory,SizeOfImage,0
	invoke SetThreadContext,PI_.hThread,ADDR context
	popad
	Ret
UsunBreakpoint EndP

SearchIID PROC 

	mov eax,[pMapVirtual]			;where the loaded
	mov ebx,context.regEdi			;call edi <-edi value
	sub ebx,[where]					;subtract from that where allocated
	mov edx,[sizeVirtual]			;Move what size load
	sub edx,ebx						;subtract the size thanks to this I know how much searched
	mov ebx,eax
	add ebx,edx
	.while eax!=ebx					;how many have finding stuff
		.if dword ptr[eax]==08B909090h		;search IID <- IMAGE_IMPORT_DESCRIPTOR
			.if dword ptr[eax+4]==0C985344Eh
				add eax,7
				sub eax,pMapVirtual
				add eax,context.regEdi
				mov [patchIID],eax
				invoke SetBreakpoint,EAX
				.break
			.endif
		.endif
		inc eax
	.endw
	Ret
SearchIID EndP

Dump PROC

	mov edi,pMemory
	assume edi:ptr IMAGE_DOS_HEADER
	add edi,[edi].e_lfanew
	assume edi:ptr IMAGE_NT_HEADERS
	push [addressIID]			;fix import tables
	pop [edi].OptionalHeader.DataDirectory[SIZEOF IMAGE_DATA_DIRECTORY].VirtualAddress
	mov eax,[edi].OptionalHeader.ImageBase
	sub [OEP],eax
	push OEP				;OEP
	pop [edi].OptionalHeader.AddressOfEntryPoint
	movzx eax,[edi].FileHeader.NumberOfSections
	mov [NumberOfSections],eax
	add edi,SIZEOF IMAGE_NT_HEADERS
	assume edi:ptr IMAGE_SECTION_HEADER
	xor ebx,ebx
	.while ebx!=[NumberOfSections]		;repair sections
		lea eax,[edi].Name1
		.if dword ptr[eax]=='EDOC'		;or section code
			push [Characteristics]		;repair sections
			pop[edi].Characteristics
		.endif
		push [edi].VirtualAddress
		pop [edi].PointerToRawData
		push [edi].Misc.VirtualSize
		pop [edi].SizeOfRawData
		add edi,SIZEOF IMAGE_SECTION_HEADER
		inc ebx
	.endw
	Ret
Dump EndP

Save PROC 

	lea eax,buffer
	invoke lstrlen,eax
	lea ebx,buffer
	add ebx,eax
	xor ecx,ecx
	.while eax!=0
		mov cl,byte ptr[ebx]
		.if cl==5Ch				;search \
			.break
		.endif
		dec ebx
		dec eax
	.endw
	inc ebx						;ebx is now in our file
	mov eax,ebx
	invoke lstrcpy,eax,OFFSET unpacked	;now we have the path and file
	INVOKE CreateFile,ADDR buffer,\		;Create a file unpacked.exe
					GENERIC_READ OR GENERIC_WRITE,\
					FILE_SHARE_READ OR FILE_SHARE_WRITE,\
					NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,\
					NULL
	.if eax!=INVALID_HANDLE_VALUE			;check if everything went okay
		mov pFile,eax
		invoke WriteFile,pFile,pMemory,SizeOfImage,ADDR SizeReadWrite,NULL 		;enter the process to file
		invoke CloseHandle,pFile												;close the file handle
		invoke MessageBox,0,addr Done,addr ok,MB_OK+MB_ICONASTERISK			    ;Everything went okay
	.else
		invoke MessageBox,0,ADDR Error_File ,ADDr Error,MB_ICONERROR
	.endif
	Ret
Save EndP

end start